package
{
	import flash.display.*;
	import flash.events.*;
	import flash.ui.*;
	import flash.utils.getTimer;
	
	[SWF (width=640, height=480, frameRate=60)]
	public class Main extends Sprite
	{
		private var time: int;

		public static var level: Level;
		
		private var oldLevel: Level;
		
		public static var audioControl : AudioControl;
		
		private var delay : int = 0;
		
		[Embed(source="images/bg.jpg")]
		public static var backgroundSrc:Class;
		
		public function Main()
		{
			addChild(new backgroundSrc());
			
			Tile.initTiles();
			
			level = new Level();
			
			addChild(level);
			
			Input.attach(stage);
			
			audioControl = new AudioControl();
			
			addChild(audioControl);
			
			time = getTimer();
			
			stage.addEventListener(Event.ENTER_FRAME, onEnterFrame);
			
		}
		
		private function onEnterFrame(e:Event):void
		{
			var dt:int = getTimer() - time;
			
			while (dt >= 20) {
				time += 20;
				dt -= 20;
				
				update(20);
			}
		}
		
		private function update (dt: int): void
		{
			if (Player.dead || Wall.stopped) {
				delay += dt;
			}
			
			if (Player.dead && delay > 1000) {
				resetLevel();
				delay = 0;
			}
			
			if (Wall.stopped && !oldLevel && delay > 3000) {
				nextLevel();
				delay = 0;
			}
			
			if (oldLevel)
			{
				oldLevel.y -= 10;
				level.y -= 10;
				
				if (level.y <= 0)
				{
					level.y = 0;
					removeChild(oldLevel);
					oldLevel = null;
				}
			}
			
			level.update(dt);
		}
		
		public function resetLevel () : void
		{
			var levelID : int = level.levelID;
			
			AudioControl.startLevel();
			
			removeChild(level);
			level = new Level(levelID);
			addChild(level);
			
			swapChildren(level, audioControl);
		}
		
		public function nextLevel () : void
		{
			var levelID : int = level.levelID;
			
			if (levelID == Level.lastLevel)
			{
				levelID = 1;
			}
			else
			{
				levelID++;
			}
			
			AudioControl.startLevel();
			
			oldLevel = level;
			
			level = new Level(levelID);
			level.y = 480;
			
			addChild(level);
			
			swapChildren(level, audioControl);
		}
	}
}
