package
{
	import flash.display.*;
	import flash.utils.*;
	import flash.geom.*;
	
	public class Tile extends Bitmap
	{
		public static const WIDTH : int = 32;
		public static const HEIGHT : int = 32;
		
		public static const EMPTY : int = 0;
		public static const RED : int = 1;
		public static const ORANGE : int = 2;
		public static const BROWN : int = 3;
		public static const PLAYER : int = 4;
		public static const WALL : int = 5;
		public static const BUTTON : int = 6;
		
		[Embed(source="images/tiles.png")]
		public static var tileImageSrc : Class;
		
		private static var tileBitmapData : Array;
		
		public var tileID : int;
		
		public function Tile (i : int)
		{
			super(tileBitmapData[i]);
			
			tileID = i;
		}
		
		public function getAABB () : Rectangle
		{
			return new Rectangle(x, y, WIDTH, HEIGHT);
		}
		
		public function update (dt : int) : void {}
		
		public static function initTiles () : void
		{
			tileBitmapData = new Array();
			
			var allTiles : BitmapData = new tileImageSrc().bitmapData;
			
			var count : int = allTiles.width / WIDTH;
			
			var rect : Rectangle = new Rectangle(0, 0, WIDTH, HEIGHT);
			
			var topleft : Point = new Point(0, 0);
			
			for (var i : int = 0; i < count; i++)
			{
				tileBitmapData[i] = new BitmapData(WIDTH, HEIGHT);
				
				rect.x = i * WIDTH;
				
				tileBitmapData[i].copyPixels(allTiles, rect, topleft);
			}
		}

		public static function create (id : String) : Tile
		{
			if (id == "0") { return null; }
			
			var index : int = parseInt(id);
			
			switch (index) {
				case PLAYER:
				case WALL:
					return new SpawnTile(index);
				case BUTTON:
					return new Button();
				default:
					return new Tile(index);
			}
		}
	}
}

