package
{
	import flash.display.*;
	import flash.geom.*;
	import flash.ui.*;
	
	public class Wall extends Sprite
	{
		[Embed(source="images/wall.png")]
		public static var wallSrc:Class;
		
		[Embed(source="images/wall-support.png")]
		public static var wallSupportSrc:Class;
		
		private var rotateable : Sprite;
		
		public static var stopped : Boolean = false;
		
		private var rotSpeed : Number = 1.0;
		
		public function Wall (_x : Number, _y : Number)
		{
			x = _x + 16;
			y = _y + 16;
			
			var bg : Bitmap = new wallSupportSrc();
			
			addChild(bg);
			
			bg.x = -16;
			bg.y = -16;
			
			rotateable = new Sprite();
			
			addChild(rotateable);
			
			var image : Bitmap = new wallSrc();
			
			rotateable.addChild(image);
			
			image.x = -16;
			image.y = -16;
			
			image.scaleX = 0.25;
			image.scaleY = 0.25;
			
			stopped = false;
		}
		
		public function getAABB () : Rectangle
		{
			return new Rectangle(x - 16, y - 16, 32, 32);
		}
		
		public function update (dt: int): void
		{
			var xOffset : Number = Main.level.player.x - x;
			var dir : int = (xOffset > 0) ? 1 : -1;
			
			if (!stopped && (dir == Player.facing || Player.dead) && (xOffset < -16 || xOffset > 16))
			{
				x += dir * 0.05 * dt
			}
			
			if (true)
			{
				var rotChange : Number = rotSpeed * dt;
				
				rotateable.rotation += rotChange;
				
				if (stopped)
				{
					rotSpeed -= 0.01;
					rotSpeed = Math.max(0, rotSpeed);
				}
				
				if (!stopped && Math.random() < 0.005)
				{
					Main.level.spark(x, y, 3, 600);
				}
			}
		}
	}
}

